<?php

    namespace Vepara\VeparaPos\Controller\Sanalpos;

    use Magento\Framework\Controller\ResultFactory;
    use Magento\Framework\App\CsrfAwareActionInterface;
    use Magento\Framework\App\RequestInterface;
    use Magento\Framework\App\Request\InvalidRequestException;
    use Magento\Quote\Model\QuoteIdToMaskedQuoteIdInterface;

    class D3 extends \Magento\Framework\App\Action\Action
    {
        protected $_context;
        protected $_pageFactory;
        protected $_jsonEncoder;
        protected $_resultRedirect;
        protected $_checkoutSession;
        protected $_customerSession;
        protected $_scopeConfig;
        protected $_storeManager;
        protected $_redirect;
        protected $_coreSession;
        protected $_messageManager;
        protected $_cartManagement;
        protected $_quoteIdToMaskedQuoteId;
        protected $_guestCartManagement;

        public function __construct(
            \Magento\Framework\App\Action\Context                            $context,
            \Magento\Framework\Json\EncoderInterface                         $encoder,
            \Magento\Framework\View\Result\PageFactory                       $pageFactory,
            \Magento\Checkout\Model\Session                                  $checkoutSession,
            \Magento\Customer\Model\Session                                  $customerSession,
            \Magento\Quote\Api\CartManagementInterface                       $cartManagement,
            \Magento\Framework\App\Config\ScopeConfigInterface               $scopeConfig,
            \Magento\Framework\Session\SessionManagerInterface               $coreSession,
            \Magento\Framework\App\Response\RedirectInterface                $redirect,
            \Magento\Framework\Message\ManagerInterface                      $messageManager,
            \Magento\Checkout\Api\GuestPaymentInformationManagementInterface $guestCartManagement,
            \Magento\Store\Model\StoreManagerInterface                       $storeManager,
            QuoteIdToMaskedQuoteIdInterface                                  $quoteIdToMaskedQuoteId

        )
        {
            $this->_context = $context;
            $this->_pageFactory = $pageFactory;
            $this->_jsonEncoder = $encoder;
            $this->_checkoutSession = $checkoutSession;
            $this->_customerSession = $customerSession;
            $this->_scopeConfig = $scopeConfig;
            parent::__construct($context);
            $this->_resultRedirect = $context->getResultFactory();
            $this->_storeManager = $storeManager;
            $this->_messageManager = $messageManager;
            $this->_redirect = $redirect;
            $this->_coreSession = $coreSession;
            $this->_cartManagement = $cartManagement;
            $this->_guestCartManagement = $guestCartManagement;
            $this->_quoteIdToMaskedQuoteId = $quoteIdToMaskedQuoteId;
            $this->checkAndSetCookieSameSite();
        }

        public function execute()
        {


            $objectManager = \Magento\Framework\App\ObjectManager::getInstance();


            $sandbox = $this->_scopeConfig->getValue('payment/vepara_pos/sandbox');
            $url = "https://app.vepara.com.tr/ccpayment/api/paySmart3D";
            if ($sandbox == 1) {
                $url = "https://test.vepara.com.tr/ccpayment/api/paySmart3D";
            }


            date_default_timezone_set("Europe/Istanbul");
            $api_key = $this->_scopeConfig->getValue('payment/vepara_pos/api_key');
            $api_secret = $this->_scopeConfig->getValue('payment/vepara_pos/api_secret');
            $merchant_key = $this->_scopeConfig->getValue('payment/vepara_pos/merchant_key');

            $cartObj = $objectManager->get('\Magento\Checkout\Model\Cart');
            $grandTotal = $cartObj->getQuote()->getGrandTotal();
            $checkoutSession = $this->_checkoutSession->getQuote();
            $data['action'] = $url;
            $callback = $this->_storeManager->getStore()->getBaseUrl() . 'vepara/sanalpos/response';
            $successUrl = $callback;

            $grandTotal = number_format($_REQUEST['odenecek_tutar'], "2", ".", "");
            $amount = $grandTotal;
            $clientRefCode = $checkoutSession->getId();

            $odemeSession = \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Checkout\Model\Session');


            $cart = \Magento\Framework\App\ObjectManager::getInstance()->get('\Magento\Checkout\Model\Cart');


            /*
             * Kargo ücreti hesaplanıyor
             */

            $shippingAddress = $cart->getQuote()->getShippingAddress();
            $shippingAmount = $shippingAddress->getShippingAmount();



            $items = $cart->getQuote()->getAllItems();
            $item_data = [];


            foreach ($items as $item) {
                $product_name = $item->getName(); // Ürün Adı
                $product_price = $item->getPrice(); // Ürün Fiyatı
                $product_qty = intval($item->getQty()); // Ürün Miktarı
                $product_id = $item->getProduct()->getId(); // Ürün ID'si

                $item_data[] = [
                    "price" => $product_price,
                    'name' => $product_name,
                    'quantity' => $product_qty,
                    'description' => $product_name." Ürünü",
                ];

            }

            $item_data[] = [
                "price" => $shippingAmount,
                'name' => "Kargo",
                'quantity' => 1,
                'description' => "Gönderi Ücreti",
            ];

            $items = json_encode($item_data);



            $billingAddress = $odemeSession->getQuote()->getBillingAddress();
            $firstName = $billingAddress->getFirstname(); // Ad
            $lastName = $billingAddress->getLastname(); // Soyad
            $street = $billingAddress->getStreet()[0]; // Adres
            $city = $billingAddress->getCity(); // Şehir
            $region = $billingAddress->getRegion();


            $postcode = $billingAddress->getPostcode(); // Posta Kodu
            $telephone = $billingAddress->getTelephone(); // Telefon
            $email = $billingAddress->getEmail(); // E-posta

            $hash_key = $this->generateHashKey($amount, $_REQUEST['secilen_taksit'], "TRY", $merchant_key, $clientRefCode, $api_secret);


            $vars = [
                'cc_holder_name' => $_REQUEST['cardHolderName'],
                'cc_no' => str_replace(" ", "", $_REQUEST['cardNumber']),
                'expiry_month' => $_REQUEST['ay'],
                'expiry_year' => $_REQUEST['yil'],
                'cvv' => $_REQUEST['cvv'],
                'currency_code' => "TRY",
                'installments_number' => intval($_REQUEST['secilen_taksit']),
                'invoice_id' => $clientRefCode,
                'invoice_description' => $clientRefCode . " Nolu Sipariş Ödemesi",
                'name' => $firstName,
                'surname' => $lastName,
                'total' => $amount,
                'merchant_key' => $merchant_key,
                'items' => $items,
                'return_url' => (string)$successUrl,
                'cancel_url' => (string)$callback,
                'hash_key' => $hash_key,
                'bill_address1' => $street,
                'bill_address2' => "",
                'bill_city' => $city,
                'bill_postcode' => $postcode,
                'bill_state' => $region,
                'bill_country' => "Türkiye",
                'bill_email' => $email,
                'bill_phone' => $telephone,
                'ip' => $this->getIp(),
                'transaction_type' => "Auth",
                'sale_webhook_key' => $clientRefCode,
                'payment_completed_by' => "app",
                'response_method' => "POST",
            ];


            ?>


            <style>
                /* Absolute Center Spinner */
                .loading {
                    position: fixed;
                    z-index: 999;
                    height: 2em;
                    width: 2em;
                    overflow: visible;
                    margin: auto;
                    top: 0;
                    left: 0;
                    bottom: 0;
                    right: 0;
                }

                /* Transparent Overlay */
                .loading:before {
                    content: '';
                    display: block;
                    position: fixed;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    background-color: rgba(0, 0, 0, 0.3);
                }

                /* :not(:required) hides these rules from IE9 and below */
                .loading:not(:required) {
                    /* hide "loading..." text */
                    font: 0/0 a;
                    color: transparent;
                    text-shadow: none;
                    background-color: transparent;
                    border: 0;
                }

                .loading:not(:required):after {
                    content: '';
                    display: block;
                    font-size: 10px;
                    width: 1em;
                    height: 1em;
                    margin-top: -0.5em;
                    -webkit-animation: spinner 1500ms infinite linear;
                    -moz-animation: spinner 1500ms infinite linear;
                    -ms-animation: spinner 1500ms infinite linear;
                    -o-animation: spinner 1500ms infinite linear;
                    animation: spinner 1500ms infinite linear;
                    border-radius: 0.5em;
                    -webkit-box-shadow: rgba(0, 0, 0, 0.75) 1.5em 0 0 0, rgba(0, 0, 0, 0.75) 1.1em 1.1em 0 0, rgba(0, 0, 0, 0.75) 0 1.5em 0 0, rgba(0, 0, 0, 0.75) -1.1em 1.1em 0 0, rgba(0, 0, 0, 0.5) -1.5em 0 0 0, rgba(0, 0, 0, 0.5) -1.1em -1.1em 0 0, rgba(0, 0, 0, 0.75) 0 -1.5em 0 0, rgba(0, 0, 0, 0.75) 1.1em -1.1em 0 0;
                    box-shadow: rgba(0, 0, 0, 0.75) 1.5em 0 0 0, rgba(0, 0, 0, 0.75) 1.1em 1.1em 0 0, rgba(0, 0, 0, 0.75) 0 1.5em 0 0, rgba(0, 0, 0, 0.75) -1.1em 1.1em 0 0, rgba(0, 0, 0, 0.75) -1.5em 0 0 0, rgba(0, 0, 0, 0.75) -1.1em -1.1em 0 0, rgba(0, 0, 0, 0.75) 0 -1.5em 0 0, rgba(0, 0, 0, 0.75) 1.1em -1.1em 0 0;
                }

                /* Animation */

                @-webkit-keyframes spinner {
                    0% {
                        -webkit-transform: rotate(0deg);
                        -moz-transform: rotate(0deg);
                        -ms-transform: rotate(0deg);
                        -o-transform: rotate(0deg);
                        transform: rotate(0deg);
                    }
                    100% {
                        -webkit-transform: rotate(360deg);
                        -moz-transform: rotate(360deg);
                        -ms-transform: rotate(360deg);
                        -o-transform: rotate(360deg);
                        transform: rotate(360deg);
                    }
                }

                @-moz-keyframes spinner {
                    0% {
                        -webkit-transform: rotate(0deg);
                        -moz-transform: rotate(0deg);
                        -ms-transform: rotate(0deg);
                        -o-transform: rotate(0deg);
                        transform: rotate(0deg);
                    }
                    100% {
                        -webkit-transform: rotate(360deg);
                        -moz-transform: rotate(360deg);
                        -ms-transform: rotate(360deg);
                        -o-transform: rotate(360deg);
                        transform: rotate(360deg);
                    }
                }

                @-o-keyframes spinner {
                    0% {
                        -webkit-transform: rotate(0deg);
                        -moz-transform: rotate(0deg);
                        -ms-transform: rotate(0deg);
                        -o-transform: rotate(0deg);
                        transform: rotate(0deg);
                    }
                    100% {
                        -webkit-transform: rotate(360deg);
                        -moz-transform: rotate(360deg);
                        -ms-transform: rotate(360deg);
                        -o-transform: rotate(360deg);
                        transform: rotate(360deg);
                    }
                }

                @keyframes spinner {
                    0% {
                        -webkit-transform: rotate(0deg);
                        -moz-transform: rotate(0deg);
                        -ms-transform: rotate(0deg);
                        -o-transform: rotate(0deg);
                        transform: rotate(0deg);
                    }
                    100% {
                        -webkit-transform: rotate(360deg);
                        -moz-transform: rotate(360deg);
                        -ms-transform: rotate(360deg);
                        -o-transform: rotate(360deg);
                        transform: rotate(360deg);
                    }
                }
            </style>

            <?php


            ?>
            <div class="loading">Loading&#8230;</div>
            <form action="<?php echo $url ?>" method="post"><?php
                    foreach ($vars as $key => $value) {
                        echo "<input type='hidden' name='" . $key . "' value='" . $value . "'><br>
                                ";
                    }
                ?>
                <input type="submit" value="GÖNDER" id="devam" style="display: none">
            </form>

            <script>
                 document.getElementById("devam").click();
            </script><?php



        }


        public function getToken($app_id, $app_secret, $token_url)
        {
            $par = [
                'app_id' => $app_id,
                'app_secret' => $app_secret,
            ];

            $token_result = json_decode($this->curl($par, $token_url));

            if ($token_result->status_code == 100) {
                return $token_result->data->token;
            }
        }

        public function curl($payload, $url, $token = "")
        {

            if (!empty($token)) {
                $header = [
                    "Authorization: Bearer $token", "Accept: application/json", "Content-Type: application/json"
                ];
            } else {
                $header = ["Accept: application/json", "Content-Type: application/json"];
            }

            $ch = curl_init();
            curl_setopt($ch, CURLOPT_HTTPHEADER, array());
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));
            $output = curl_exec($ch);
            curl_close($ch);

            return $output;
        }

        public function generateHashKey($total, $installment, $currency_code, $merchant_key, $invoice_id, $app_secret)
        {
            $data = $total . '|' . $installment . '|' . $currency_code . '|' . $merchant_key . '|' . $invoice_id;
            $iv = substr(sha1(mt_rand()), 0, 16);
            $password = sha1($app_secret);
            $salt = substr(sha1(mt_rand()), 0, 4);
            $saltWithPassword = hash('sha256', $password . $salt);
            $encrypted = openssl_encrypt("$data", 'aes-256-cbc', "$saltWithPassword", 0, $iv);
            $msg_encrypted_bundle = "$iv:$salt:$encrypted";
            $msg_encrypted_bundle = str_replace('/', '__', $msg_encrypted_bundle);
            return $msg_encrypted_bundle;
        }

        public function generateHashComplete($merchant_key, $invoice_id, $order_id, $status, $app_secret)
        {
            $data = $merchant_key . '|' . $invoice_id . '|' . $order_id . '|' . $status;
            $iv = substr(sha1(mt_rand()), 0, 16);
            $password = sha1($app_secret);

            $salt = substr(sha1(mt_rand()), 0, 4);
            $saltWithPassword = hash('sha256', $password . $salt);

            $encrypted = openssl_encrypt(
                "$data", 'aes-256-cbc', "$saltWithPassword", 0, $iv
            );
            $msg_encrypted_bundle = "$iv:$salt:$encrypted";
            $msg_encrypted_bundle = str_replace('/', '__', $msg_encrypted_bundle);
            return $msg_encrypted_bundle;
        }

        function validateHashKey($hashKey, $secretKey)
        {
            $status = $currencyCode = "";
            $total = $invoiceId = $orderId = 0;
            if (!empty($hashKey)) {
                $hashkey = str_replace('__', '/', $hashKey);
                $password = sha1($secretKey);
                $components = explode(':', $hashkey);
                if (count($components) > 2) {
                    $iv = isset($components[0]) ? $components[0] : "";
                    $salt = isset($components[1]) ? $components[1] : "";
                    $salt = hash('sha256', $password . $salt);
                    $encryptedMsg = isset($components[2]) ? $components[2] : "";
                    $decryptedMsg = openssl_decrypt($encryptedMsg, 'aes-256-cbc', $salt, null, $iv);
                    if (strpos($decryptedMsg, '|') !== false) {
                        $array = explode('|', $decryptedMsg);
                        $status = isset($array[0]) ? $array[0] : 0;
                        $total = isset($array[1]) ? $array[1] : 0;
                        $invoiceId = isset($array[2]) ? $array[2] : '0';
                        $orderId = isset($array[3]) ? $array[3] : 0;
                        $currencyCode = isset($array[4]) ? $array[4] : '';
                    }
                    return [$status, $total, $invoiceId, $orderId, $currencyCode];
                }
            }
        }

        public function getIp()
        {
            if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
                $ip = $_SERVER['HTTP_CLIENT_IP'];
            } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
                $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
            } else {
                $ip = $_SERVER['REMOTE_ADDR'];
            }

            return $ip;
        }

        public function amountTemizle($amount)
        {
            $amount = trim($amount);
            $amount = str_replace(".0000", "", $amount);
            $amount = str_replace(".00", "", $amount);
            return $amount;
        }




        private function checkAndSetCookieSameSite()
        {
            foreach ($_COOKIE as $cookieName => $value) {
                $this->setcookieSameSite($cookieName, $_COOKIE[$cookieName], time() + 86400, "/", $_SERVER['SERVER_NAME'], true, true);
            }
        }

        private function setcookieSameSite($name, $value, $expire, $path, $domain, $secure, $httponly)
        {

            if (PHP_VERSION_ID < 70300) {

                setcookie($name, $value, $expire, "$path; samesite=None", $domain, $secure, $httponly);
            } else {
                setcookie($name, $value, [
                    'expires' => $expire,
                    'path' => $path,
                    'domain' => $domain,
                    'samesite' => 'None',
                    'secure' => $secure,
                    'httponly' => $httponly
                ]);


            }
        }

    }